Index: fact/tools/rootmacros/PulseTemplates/pixel.C
===================================================================
--- fact/tools/rootmacros/PulseTemplates/pixel.C	(revision 15120)
+++ fact/tools/rootmacros/PulseTemplates/pixel.C	(revision 15369)
@@ -442,4 +442,5 @@
                     (mGainMean*(order+1)) + 10,
                     "Y");
+        hMaxOverlay[order]->SetDrawOption("colz");
         hMaxOverlay[order]->GetXaxis()->SetTitle( "Timeslices [a.u.]" );
         hMaxOverlay[order]->GetYaxis()->SetTitle( "Amplitude [mV]" );
@@ -466,4 +467,5 @@
                     (mGainMean*(order+1)) + 10,
                     "Y");
+        hEdgeOverlay[order]->SetDrawOption("colz");
         hEdgeOverlay[order]->GetXaxis()->SetTitle( "Timeslices [a.u.]" );
         hEdgeOverlay[order]->GetYaxis()->SetTitle( "Amplitude [mV]" );
@@ -629,6 +631,6 @@
                     "hMaxPos",
                     "Distribution of arrival times according to the EdgePos",
-                    1024,
-                    0,
+                    1025,
+                    -1,
                     1024
                     );
@@ -637,4 +639,5 @@
 //                                1024,
 //                                "X");
+        hMaxPos->SetDrawOption("colz");
         hMaxPos->GetXaxis()->SetTitle( " arrival time [timeslices]" );
         hMaxPos->GetYaxis()->SetTitle( "counts" );
@@ -646,7 +649,7 @@
                     "hEdgePos",
                     "Distribution of arrival times according to the EdgePos",
-                    1024,
-                    0,
-                    1024
+                    1125,
+                    -1,
+                    1124
                     );
 //            hEdgePos->SetAxisRange(
@@ -654,4 +657,5 @@
 //                                1024,
 //                                "X");
+        hEdgePos->SetDrawOption("colz");
         hEdgePos->GetXaxis()->SetTitle( " arrival time [timeslices]" );
         hEdgePos->GetYaxis()->SetTitle( "counts" );
@@ -665,16 +669,37 @@
                     "hEdgeSlope",
                     "Distribution of slope of leading edges",
-                    100*10,
-                    -9,
-                    90
-                    );
-//            hEdgeSlope->SetAxisRange(
-//                                0,
-//                                1024,
-//                                "X");
+                    100,
+                    -1.55,
+                    8.45
+                    );
+        hEdgeSlope->SetAxisRange(
+                                0.5,
+                                7,
+                                "X");
+        hEdgeSlope->SetDrawOption("colz");
         hEdgeSlope->GetXaxis()->SetTitle( " slope [a.u.]" );
         hEdgeSlope->GetYaxis()->SetTitle( "counts" );
         hEdgeSlope->SetStats(mStats);
         hList->Add( hEdgeSlope );
+
+        // Edge Slope Distributions
+        //----------------------------------
+        if (mVerbosityLevel > 3) cout << "\t...booking " << "hMaxEdgeSlope" << endl;
+        hMaxEdgeSlope = new TH1F (
+                    "hMaxEdgeSlope",
+                    "Distribution of maximum slope in slices of leading edges",
+                    100,
+                    -1.55,
+                    8.45
+                    );
+        hMaxEdgeSlope->SetAxisRange(
+                                0.5,
+                                7,
+                                "X");
+        hMaxEdgeSlope->SetDrawOption("colz");
+        hMaxEdgeSlope->GetXaxis()->SetTitle( " slope [a.u.]" );
+        hMaxEdgeSlope->GetYaxis()->SetTitle( "counts" );
+        hMaxEdgeSlope->SetStats(mStats);
+        hList->Add( hMaxEdgeSlope );
 
         // Intercept Distributions
@@ -684,12 +709,13 @@
                     "hIntercept",
                     "Distribution of Intercept of leading edges",
-                    100*10,
-                    -9,
-                    90
-                    );
-//            hEdgeSlope->SetAxisRange(
-//                                0,
-//                                1024,
-//                                "X");
+                    1041,
+                    -1,
+                    1040
+                    );
+        hIntercept->SetAxisRange(
+                                -100,
+                                100,
+                                "X");
+        hIntercept->SetDrawOption("colz");
         hIntercept->GetXaxis()->SetTitle( " Intercept [a.u.]" );
         hIntercept->GetYaxis()->SetTitle( "counts" );
@@ -701,14 +727,15 @@
         if (mVerbosityLevel > 3) cout << "\t...booking " << "hEdgeLength" << endl;
         hEdgeLength = new TH1F (
-                    "hIntercept",
+                    "hEdgeLength",
                     "Distribution of hEdgeLength of leading edges",
-                    20*10,
-                    0,
-                    20
-                    );
-//            hEdgeLength->SetAxisRange(
-//                                0,
-//                                1024,
-//                                "X");
+                    200,
+                    -0.5,
+                    199.5
+                    );
+        hEdgeLength->SetAxisRange(
+                                0,
+                                100,
+                                "X");
+        hEdgeLength->SetDrawOption("colz");
         hEdgeLength->GetXaxis()->SetTitle( " edge length [a.u.]" );
         hEdgeLength->GetYaxis()->SetTitle( "counts" );
@@ -723,11 +750,12 @@
                     "Distribution of pulse lengthes",
                     1024,
-                    0,
-                    1024
-                    );
-//            hPulseLength->SetAxisRange(
-//                                0,
-//                                1024,
-//                                "X");
+                    -0.5,
+                    1023.5
+                    );
+            hPulseLength->SetAxisRange(
+                                0,
+                                600,
+                                "X");
+        hPulseLength->SetDrawOption("colz");
         hPulseLength->GetXaxis()->SetTitle( " pulse length [samples]" );
         hPulseLength->GetYaxis()->SetTitle( "counts" );
@@ -740,6 +768,6 @@
                     "Distribution of pulse lengthes due to afterpulse cut off",
                     1024,
-                    0,
-                    1024
+                    -0.5,
+                    1023.5
                     );
 //            hPulseLength->SetAxisRange(
@@ -747,4 +775,5 @@
 //                                1024,
 //                                "X");
+        hPulseLengthAPcutoff->SetDrawOption("colz");
         hPulseLengthAPcutoff->GetXaxis()->SetTitle( " pulse length [samples]" );
         hPulseLengthAPcutoff->GetYaxis()->SetTitle( "counts" );
@@ -757,6 +786,6 @@
                     "Distribution of pulse lengthes due to time line cut off",
                     1024,
-                    0,
-                    1024
+                    -0.5,
+                    1023.5
                     );
 //            hPulseLengthTLcutoff->SetAxisRange(
@@ -764,4 +793,5 @@
 //                                1024,
 //                                "X");
+        hPulseLengthTLcutoff->SetDrawOption("colz");
         hPulseLengthTLcutoff->GetXaxis()->SetTitle( " pulse length [samples]" );
         hPulseLengthTLcutoff->GetYaxis()->SetTitle( "counts" );
@@ -776,7 +806,7 @@
                     "hMaxAmpl",
                     "Distribution of MaxAmpl of leading edges",
-                    20*10,
+                    100*10,
                     0,
-                    20
+                    100
                     );
 //            hMaxAmpl->SetAxisRange(
@@ -784,27 +814,33 @@
 //                                1024,
 //                                "X");
+        hMaxAmpl->SetDrawOption("colz");
         hMaxAmpl->GetXaxis()->SetTitle( " Amplitude [a.u.]" );
         hMaxAmpl->GetYaxis()->SetTitle( "counts" );
         hMaxAmpl->SetStats(mStats);
-        hList->Add( hEdgeLength );
+        hList->Add( hMaxAmpl );
 
         // Discarted Pulses Distributions
         //----------------------------------
         if (mVerbosityLevel > 3) cout << "\t...booking " << "hDiscartedPulses" << endl;
-        hDiscartedPulses=new TH2F(
+        hDiscartedPulses=new TProfile(
                     "hDiscartedPulses",
                     "DiscartedPulses vs. preperation step",
                     15 ,
+                    -0.5,
+                    14.5 /*,
+                    100,
                     0,
-                    15 ,
-                    1000000,
-                    0,
-                    1000000
-                    );
-
-//            hMaxOverlay[order]->SetAxisRange(
-//                        mBSLMean - 5,
-//                        (mGainMean*(order+1)) + 10,
+                    1*/
+                    );
+
+//        hDiscartedPulses->SetAxisRange(
+//                        0,
+//                        50,
 //                        "Y");
+        hDiscartedPulses->SetAxisRange(
+                        -0.5,
+                        9.5,
+                        "X");
+        hDiscartedPulses->SetDrawOption("colz");
         hDiscartedPulses->GetXaxis()->SetTitle( "step [a.u.]" );
         hDiscartedPulses->GetYaxis()->SetTitle( "# discartep pulses [a.u.]" );
@@ -815,5 +851,5 @@
         // Afterpulse Distributions
         //----------------------------------
-        if (mVerbosityLevel > 3) cout << "\t...booking " << hAfterPulses << endl;
+        if (mVerbosityLevel > 3) cout << "\t...booking " << "hAfterPulses" << endl;
         hAfterPulses=new TH2F(
                     "hAfterPulses",
@@ -831,4 +867,5 @@
 //                        (mGainMean*(order+1)) + 10,
 //                        "Y");
+        hAfterPulses->SetDrawOption("colz");
         hAfterPulses->GetXaxis()->SetTitle( "delay [sample/ 0.5 ns]" );
         hAfterPulses->GetYaxis()->SetTitle( "amplitude [mV]" );
@@ -1133,4 +1170,5 @@
     delete hEdgePos;
     delete hEdgeSlope;
+    delete hMaxEdgeSlope;
     delete hIntercept;
     delete hEdgeLength;