Index: trunk/FACT++/www/showlog.css
===================================================================
--- trunk/FACT++/www/showlog.css	(revision 15373)
+++ trunk/FACT++/www/showlog.css	(revision 15373)
@@ -0,0 +1,81 @@
+.up {
+    cursor:pointer;
+    padding:0 5px 4px 7px;
+    position:fixed;
+    top:0;
+    right:0;
+    text-decoration:underline;
+    color:navy;
+    background-color:#ebe7e6;
+}
+
+.dn {
+    cursor:pointer;
+    padding:0 5px 4px 7px;
+    padding-top:0px;
+    position:fixed;
+    bottom:0;
+    right:0;
+    text-decoration:underline;
+    color:navy;
+    background-color:#ebe7e6;
+}
+
+#nav {
+    position:fixed;
+    right:80px;
+    top:0;
+    background-color:#ebe7e6;
+}
+
+#nav ul {
+    list-style-type:none;
+    margin:0;
+    padding:0;
+}
+
+#nav li {
+    float:left;
+    padding:0;
+    margin:0;
+}
+
+#nav li a {
+    padding:0 9px 4px 11px;
+    display:block;
+    color:#000; 
+    color:navy;
+    text-decoration:none; 
+    solid #ccc; 
+}
+
+#nav li a:hover { 
+    color:#f00; 
+}
+
+#nav ul ul {
+    display:none; 
+    position:absolute; 
+    z-index:999; 
+}
+
+#nav li li { 
+    float:none; 
+}
+
+#nav li li a { 
+    background:#EBE7E6!important; 
+    text-align:left; 
+    height:auto; 
+    line-height:1; 
+    width:auto; 
+    padding:4px 20px 4px 22px; 
+    border:1px solid #D0D0D0; 
+    border-top:none; 
+    margin-right:0; 
+}
+
+/* IE6 Bugfix... */
+* html li li { 
+    display:inline; 
+} 
Index: trunk/FACT++/www/showlog.php
===================================================================
--- trunk/FACT++/www/showlog.php	(revision 15366)
+++ trunk/FACT++/www/showlog.php	(revision 15373)
@@ -362,4 +362,6 @@
 <meta charset="UTF-8">
 <title><?php print($dir." - ".$name);?></title>
+<link rel="stylesheet" type="text/css" href="showlog.css" />
+<script src="http://ajax.googleapis.com/ajax/libs/jquery/1.6.1/jquery.min.js" type="text/javascript"></script>
 <script>
 function scroll(top)
@@ -367,9 +369,49 @@
    document.getElementById(top?'top':'bottom').scrollIntoView(top);
 }
+$(document).ready(function() {
+	$("#nav li:has(ul)").hover(function(){
+		$(this).find("ul").slideDown(200);
+	}, function(){
+		$(this).find("ul").hide();
+	});
+});
 </script>
 </head>
 <body onload="setTimeout(function(){scroll(false);},1);">
-<span onclick="scroll(true);" style="cursor:pointer;padding:0 5px 4px 7px;position:fixed;top:0;right:0;text-decoration:underline;color:navy;background-color:#f0f0f0;">go to top &uarr;</span>
-<span onclick="scroll(false);" style="cursor:pointer;padding:0 5px 4px 7px;padding-top:0px;position:fixed;bottom:0;right:0;text-decoration:underline;color:navy;background-color:#f0f0f0;">go to bottom &darr;</span>
+<span onclick="scroll(true);" class="up">go to top &uarr;</span>
+<span id="nav">
+   <ul>
+      <li>
+	 <a>Logs</a>
+            <ul>
+	       <li><a href="?log=biasctrl">biasctrl</a></li>
+	       <li><a href="?log=agilentctrl">agilentctrl</a></li>
+	       <li><a href="?log=chatserv">chatserv</a></li>
+	       <li><a href="?log=datalogger">datalogger</a></li>
+	       <li><a href="?log=dimserver"><b>dimserver</b></a></li>
+	       <li><a href="?log=dimctrl">dimctrl</a></li>
+	       <li><a href="?log=drivectrl">drivectrl</a></li>
+	       <li><a href="?log=fadctrl">fadctrl</a></li>
+	       <li><a href="?log=feedback">feedback</a></li>
+	       <li><a href="?log=fscctrl">fscctrl</a></li>
+	       <li><a href="?log=ftmctrl">ftmctrl</a></li>
+	       <li><a href="?log=lidctrl">lidctrl</a></li>
+	       <li><a href="?log=magiclidar">magiclidar</a></li>
+	       <li><a href="?log=magicweather">magicweather</a></li>
+	       <li><a href="?log=mcp">mcp</a></li>
+	       <li><a href="?log=pwrctrl">pwrctrl</a></li>
+	       <li><a href="?log=ratecontrol">ratecontrol</a></li>
+	       <li><a href="?log=ratescan">ratescan</a></li>
+	       <li><a href="?log=temperature">temperature</a></li>
+	       <li><a href="?log=timecheck">timecheck</a></li>
+	       <li><a href="?log=tngweather">tngweather</a></li>
+            </ul>
+      </li>
+   </ul>
+</span>
+</span>
+<span onclick="scroll(false);" class="dn">go to bottom &darr;</span>
+
+
 <H2 id="top"><?php printf("%s - %s   (%dkB)", $dir, $name, $size/1000);?></H2>
 