Index: trunk/FACT++/src/EventBuilder.c
===================================================================
--- trunk/FACT++/src/EventBuilder.c	(revision 15366)
+++ trunk/FACT++/src/EventBuilder.c	(revision 15379)
@@ -866,5 +866,5 @@
    evtCtrl.lastPtr %= MAX_EVT * MAX_RUN;
 
-   gi.evtGet++;
+   //gi.evtGet++;
 
    return i;
@@ -939,5 +939,5 @@
 } /*-----------------------------------------------------------------*/
 
-
+/*
 void
 resetEvtStat ()
@@ -973,5 +973,5 @@
 
    return;
-} /*-----------------------------------------------------------------*/
+}*/ /*-----------------------------------------------------------------*/
 
 void reportIncomplete(int k0)
@@ -1223,7 +1223,7 @@
       for (int k = 0; k < NBOARDS; k++) {
          gi_NumConnect[k] = 0;
-         gi.numConn[k] = 0;
+         //gi.numConn[k] = 0;
          gj.numConn[k] = 0;
-         gj.errConn[k] = 0;
+         //gj.errConn[k] = 0;
          gj.rateBytes[k] = 0;
          gj.totBytes[k] = 0;
@@ -1234,5 +1234,5 @@
 
    if (gi_resetR > 0) {
-      resetEvtStat ();
+      //resetEvtStat ();
       gj.bufTot = gj.maxEvt = gj.xxxEvt = 0;
       gj.usdMem = gj.maxMem = gj.xxxMem = 0;
@@ -1276,5 +1276,5 @@
 
           gi_NumConnect[b] = 0;       //must close all connections
-          gi.numConn[b] = 0;
+          //gi.numConn[b] = 0;
           gj.numConn[b] = 0;
 
@@ -1303,5 +1303,5 @@
 
       //count number of succesfull actions
-      int numok = 0;                
+//      int numok = 0;
 
 /*
@@ -1363,8 +1363,8 @@
               gi_NumConnect[b] += cntsock;
 
-              gi.numConn[b]++;
+              //gi.numConn[b]++;
               gj.numConn[b]++;
 
-              factPrintf(kInfo, -1, "New connection %d (number of connections: %d)", b, gi.numConn[b]);
+              factPrintf(kInfo, -1, "New connection %d (number of connections: %d)", b, gj.numConn[b]);
           }
 
@@ -1373,5 +1373,5 @@
               continue;
 
-          numok++;
+          //numok++;
 
           const int32_t jrd =
@@ -1385,10 +1385,10 @@
               if (errno==EWOULDBLOCK || errno==EAGAIN)
               {
-                  numok--;
+                  //numok--;
                   continue;
               }
 
               factPrintf(kError, 442, "Reading from socket %d failed: %m (recv,rc=%d)", i, errno);
-              gi.gotErr[b]++;
+              //gi.gotErr[b]++;
               continue;
           }
@@ -1402,8 +1402,8 @@
               GenSock(s0, i, 0, NULL, &rd[i]);
 
-              gi.gotErr[b]++;
+              //gi.gotErr[b]++;
 
               gi_NumConnect[b]-= cntsock ;
-              gi.numConn[b]--;
+              //gi.numConn[b]--;
               gj.numConn[b]--;
 
@@ -1413,5 +1413,5 @@
           // Success (jrd > 0)
 
-          gi.gotByte[b]   += jrd;
+          //gi.gotByte[b]   += jrd;
           gj.rateBytes[b] += jrd;
 
@@ -1438,5 +1438,5 @@
                   rd[i].rBuf->B[rd[i].fadLen - 2] != stop.B[1])
               {
-                  gi.evtErr++;
+                  //gi.evtErr++;
                   factPrintf(kError, 301, "End-of-event flag wrong on socket %3d for event %4d (len=%5d), expected %3d %3d, got %3d %3d",
                              i, rd[i].evtID, rd[i].fadLen, stop.B[0], stop.B[1],
@@ -1531,5 +1531,5 @@
               {
                   evtCtrl.evtStat[iDx] = 99;
-                  gi.evtTot++;
+                  //gi.evtTot++;
               }
           }
@@ -1624,5 +1624,5 @@
       } // end for loop over all sockets
 
-      gi.numRead[numok]++;
+      //gi.numRead[numok]++;
 
       g_actTime = time (NULL);
@@ -1661,6 +1661,6 @@
 
               evtCtrl.evtStat[k0] = 91;     //timeout for incomplete events
-              gi.evtSkp++;
-              gi.evtTot++;
+              //gi.evtSkp++;
+              //gi.evtTot++;
               gj.evtSkip++;
 
@@ -1753,5 +1753,5 @@
 
            gi_NumConnect[i / 7]-= cntsock ;
-           gi.numConn[i / 7]--;
+           //gi.numConn[i / 7]--;
            gj.numConn[i / 7]--;
            sockDef[i / 7] = 0;      //flag ro recreate the sockets ...
@@ -1769,6 +1769,6 @@
            {
                evtCtrl.evtStat[k0] = 91;
-               gi.evtSkp++;
-               gi.evtTot++;
+               //gi.evtSkp++;
+               //gi.evtTot++;
            }
        }
@@ -2123,5 +2123,5 @@
            const int rc = eventCheck(mBuffer[id].runNum, mBuffer[id].FADhead,
                                      mBuffer[id].fEvent);
-           gi.procTot++;
+           //gi.procTot++;
            numProc++;
 
@@ -2129,5 +2129,5 @@
            {
                evtCtrl.evtStat[k0] = 9999;        //flag event to be skipped
-               gi.procErr++;
+               //gi.procErr++;
            }
            else
@@ -2307,5 +2307,5 @@
            const int32_t  ievt = mBuffer[id].evNum;
 
-           gi.wrtTot++;
+           //gi.wrtTot++;
 
            int j = lastRun;
@@ -2323,5 +2323,5 @@
                {
                    factPrintf(kFatal, 901, "writeEvt: Can not find run %d for event %d in %d", irun, ievt, id);
-                   gi.wrtErr++;
+                   //gi.wrtErr++;
                }
 
@@ -2371,5 +2371,5 @@
                }
                evtCtrl.evtStat[k0] = 9903;
-               gi.wrtErr++;
+               //gi.wrtErr++;
            } else {
                // snprintf (str, MXSTR,"write event %d size %d",ievt,sizeof (mBuffer[id]));
@@ -2388,5 +2388,5 @@
                    factPrintf(kError, 503, "writeEvt: Writing event for run %d failed (runWrite)", irun);
                    evtCtrl.evtStat[k0] = 9902;
-                   gi.wrtErr++;
+                   //gi.wrtErr++;
                }
 
Index: trunk/FACT++/src/EventBuilderWrapper.h
===================================================================
--- trunk/FACT++/src/EventBuilderWrapper.h	(revision 15366)
+++ trunk/FACT++/src/EventBuilderWrapper.h	(revision 15379)
@@ -102,5 +102,5 @@
     DimDescribedService fDimDrsCalibration;
     DimDescribedService fDimStatistics1;
-    DimDescribedService fDimStatistics2;
+    //DimDescribedService fDimStatistics2;
     DimDescribedService fDimFileFormat;
     DimDescribedService fDimIncomplete;
@@ -233,5 +233,5 @@
                                                            "|roi:Region of interest of secondary baseline"
                                                            "|run:Run numbers of DRS runs (0=none)"),
-        fDimStatistics1 ("FAD_CONTROL/STATISTICS1",        "I:3;I:5;X:4;I:3;I:3;I:40;I:1;I:2;C:40;I:40;I:40;X:40",
+        fDimStatistics1 ("FAD_CONTROL/STATISTICS1",        "I:3;I:5;X:4;I:3;I:3;I:40;I:1;I:2;C:40;I:40;X:40",
                                                            "Event Builder status for GUI display"
                                                            "|threadInfo[int]:Number of read, proc and writes"
@@ -244,8 +244,7 @@
                                                            "|rateNew[int]:Number of new start events received"
                                                            "|numConn[int]:Number of connections per board"
-                                                           "|errConn[int]:IO errors per board"
                                                            "|rateBytes[int]:Bytes read this cycle"
                                                            "|totBytes[int]:Bytes read (counter)"),
-        fDimStatistics2 ("FAD_CONTROL/STATISTICS2",        "I:1;I:280;X:40;I:40;I:4;I:4;I:2;I:2;I:3;C:40",
+        /*fDimStatistics2 ("FAD_CONTROL/STATISTICS2",        "I:1;I:280;X:40;I:40;I:4;I:4;I:2;I:2;I:3;C:40",
                                                            "Event Builder status, events oriented"
                                                            "|reset[int]:If increased, reset all counters"
@@ -258,5 +257,5 @@
                                                            "|wrtStat[int]:number of evts written to disk, with errors"
                                                            "|runStat[int]:number of run opened, closed, with open or close errors"
-                                                           "|numConn[int]:number of sockets successfully opened per board"),
+                                                           "|numConn[int]:number of sockets successfully opened per board"),*/
         fDimFileFormat("FAD_CONTROL/FILE_FORMAT",          "S:1", "|format[int]:Current file format"),
         fDimIncomplete("FAD_CONTROL/INCOMPLETE",           "X:1", "|incomplete[bits]:One bit per board"),
@@ -1239,5 +1238,5 @@
     void factStat(const EVT_STAT &stat)
     {
-        fDimStatistics2.Update(stat);
+        //fDimStatistics2.Update(stat);
     }
 
Index: trunk/FACT++/src/FAD.h
===================================================================
--- trunk/FACT++/src/FAD.h	(revision 15366)
+++ trunk/FACT++/src/FAD.h	(revision 15379)
@@ -336,5 +336,5 @@
   //connections
    int8_t   numConn[NBOARDS] ;  //#connections per board (at the moment)
-   int32_t  errConn[NBOARDS] ;  //#I/O errors per board (counter)
+   //int32_t  errConn[NBOARDS] ;  //#I/O errors per board (counter)
    int32_t  rateBytes[NBOARDS]; //#Bytes read this cycle  **
    int64_t  totBytes[NBOARDS];  //#Bytes read (counter)