Index: schedule/function/SplitDelete.php
===================================================================
--- schedule/function/SplitDelete.php	(revision 15773)
+++ schedule/function/SplitDelete.php	(revision 15774)
@@ -11,5 +11,5 @@
 			input = document.createElement("input"),
 					input.setAttribute("type","time"),
-					input.setAttribute("id","Time"),
+					input.setAttribute("id","Time1"),
 					input.setAttribute("max","24"),
 					input.setAttribute("min","1"),
@@ -20,5 +20,5 @@
 		td.appendChild(
 			sourcecbo= document.createElement('select'),
-				sourcecbo.setAttribute('id','source'),
+				sourcecbo.setAttribute('id','source1'),
 <?php
 			$source=mysql_query("SELECT*FROM source");
@@ -39,5 +39,5 @@
 			}
 ?>
-			sourcecbo.setAttribute('id','source')
+			sourcecbo.setAttribute('id','source1')
 					
 		);
@@ -46,5 +46,5 @@
 		td1.appendChild(
 			measurementcbo= document.createElement('select'),
-				measurementcbo.setAttribute('id','measurement'),
+				measurementcbo.setAttribute('id','measurement1'),
 <?php
 			$measure=mysql_query("SELECT*FROM measurement");
@@ -61,5 +61,5 @@
 			}
 ?>
-			measurementcbo.setAttribute('id','measurement')
+			measurementcbo.setAttribute('id','measurement1')
 		);
 	var td2=document.createElement('td');
@@ -68,5 +68,5 @@
 			input = document.createElement('input'),
 			input.setAttribute('type','text'),
-			input.setAttribute('id','txtData')
+			input.setAttribute('id','txtData1')
 			
 		);
@@ -112,5 +112,5 @@
 			input = document.createElement("input"),
 					input.setAttribute("type","time"),
-					input.setAttribute("id","Time"),
+					input.setAttribute("id","Time2"),
 					input.setAttribute("max","24"),
 					input.setAttribute("min","1"),
@@ -121,5 +121,5 @@
 		td.appendChild(
 			sourcecbo= document.createElement('select'),
-				sourcecbo.setAttribute('id','source'),
+				sourcecbo.setAttribute('id','source2'),
 <?php
 				$source=mysql_query("SELECT*FROM source");
@@ -137,5 +137,5 @@
 				}
  ?>
-			sourcecbo.setAttribute('id','source')
+			sourcecbo.setAttribute('id','source2')
 					
 		);
@@ -144,5 +144,5 @@
 		td1.appendChild(
 			measurementcbo= document.createElement('select'),
-				measurementcbo.setAttribute('id','measurement'),
+				measurementcbo.setAttribute('id','measurement2'),
 <?php
 			$measure=mysql_query("SELECT*FROM measurement");
@@ -159,5 +159,5 @@
 			}
 ?>
-			measurementcbo.setAttribute('id','measurement')
+			measurementcbo.setAttribute('id','measurement2')
 		);
 	var td2=document.createElement('td');
@@ -166,5 +166,5 @@
 			input = document.createElement('input'),
 			input.setAttribute('type','text'),
-			input.setAttribute('id','txtData')
+			input.setAttribute('id','txtData2')
 			
 		);
@@ -213,5 +213,5 @@
 				input = document.createElement("input"),
 						input.setAttribute("type","time"),
-						input.setAttribute("id","Time"),
+						input.setAttribute("id","Time"+cnt),
 						input.setAttribute("max","24"),
 						input.setAttribute("min","1"),
@@ -222,5 +222,5 @@
 			td.appendChild(
 				sourcecbo= document.createElement('select'),
-					sourcecbo.setAttribute('id','source'),
+					sourcecbo.setAttribute('id','source'+cnt),
 <?php
 				$source=mysql_query("SELECT*FROM source");
@@ -238,5 +238,5 @@
 				}
  ?>
-				sourcecbo.setAttribute('id','source')
+				sourcecbo.setAttribute('id','source'+cnt)
 						
 			);
@@ -245,5 +245,5 @@
 			td1.appendChild(
 				measurementcbo= document.createElement('select'),
-					measurementcbo.setAttribute('id','measurement'),
+					measurementcbo.setAttribute('id','measurement'+cnt),
 <?php
 			$measure=mysql_query("SELECT*FROM measurement");
@@ -260,5 +260,5 @@
 			}
 ?>
-			measurementcbo.setAttribute('id','measurement')
+			measurementcbo.setAttribute('id','measurement'+cnt)
 			);
 		var td2=document.createElement('td');
@@ -267,5 +267,5 @@
 				input = document.createElement('input'),
 				input.setAttribute('type','text'),
-				input.setAttribute('id','txtData')
+				input.setAttribute('id','txtData'+cnt)
 				
 			);
@@ -313,5 +313,5 @@
 				input = document.createElement("input"),
 						input.setAttribute("type","time"),
-						input.setAttribute("id","Time"),
+						input.setAttribute("id","Time"+cnt),
 						input.setAttribute("max","24"),
 						input.setAttribute("min","1"),
@@ -322,5 +322,5 @@
 			td.appendChild(
 				sourcecbo= document.createElement('select'),
-					sourcecbo.setAttribute('id','source'),
+					sourcecbo.setAttribute('id','source'+cnt),
 <?php
 				$source=mysql_query("SELECT*FROM source");
@@ -338,5 +338,5 @@
 				}
  ?>
-				sourcecbo.setAttribute('id','source')
+				sourcecbo.setAttribute('id','source'+cnt)
 						
 			);
@@ -345,5 +345,5 @@
 			td1.appendChild(
 				measurementcbo= document.createElement('select'),
-					measurementcbo.setAttribute('id','measurement'),
+					measurementcbo.setAttribute('id','measurement'+cnt),
 <?php
 			$measure=mysql_query("SELECT*FROM measurement");
@@ -360,5 +360,5 @@
 			}
 ?>
-			measurementcbo.setAttribute('id','measurement')
+			measurementcbo.setAttribute('id','measurement'+cnt)
 			);
 		var td2=document.createElement('td');
@@ -367,5 +367,5 @@
 				input = document.createElement('input'),
 				input.setAttribute('type','text'),
-				input.setAttribute('id','txtData')
+				input.setAttribute('id','txtData'+cnt)
 				
 			);
Index: schedule/function/function.php
===================================================================
--- schedule/function/function.php	(revision 15773)
+++ schedule/function/function.php	(revision 15774)
@@ -6,5 +6,7 @@
 	var year = currentDate.getFullYear();
 	var fullday=day+'-'+month+'-'+year;
+	
 	<?php
+	
 		$cntsource=mysql_query("SELECT COUNT(*) as `SourceID` FROM source");
 		$rowcnt=mysql_fetch_array($cntsource);
@@ -36,7 +38,5 @@
 		window.location = 'Transaction/insert.php?Time='+selectedTime+'&Source='+selectedSource+'&measure='+selectedMeasurement+'&Data='+InputValue+'&Date='+fullday;
 	});
-	$('#loadprev').click(function(){
-		addSeries(chart);
-	});
+	
 	});
  </script>